From 19305e9c1beffb34b73c71f721a6dea2b9fc483f Mon Sep 17 00:00:00 2001
From: sebastien_rossi <sebastien.rossi@bbright.com>
Date: Thu, 23 Jun 2022 17:20:06 +0200
Subject: [PATCH] avformat/mpegts: correct timestamp overflow on multiple pcr
 loopback

---
 libavformat/mpegts.c         |   45 +-
 tests/ref/fate/ts-opus-demux | 1028 +++++++++++++++++-----------------
 2 files changed, 556 insertions(+), 517 deletions(-)

diff --git a/libavformat/mpegts.c b/libavformat/mpegts.c
index 8a3436f2be..e1043335d6 100644
--- a/libavformat/mpegts.c
+++ b/libavformat/mpegts.c
@@ -100,6 +100,7 @@ struct MpegTSFilter {
     int es_id;
     int last_cc; /* last cc code (-1 if first packet) */
     int64_t last_pcr;
+    int pcr_loopback_count;
     int discard;
     enum MpegTSFilterType type;
     union {
@@ -272,6 +273,27 @@ typedef struct PESContext {
 
 extern const AVInputFormat ff_mpegts_demuxer;
 
+static int64_t preserve_continuity(const MpegTSFilter* filter, int64_t timestamp)
+{
+    if (timestamp < 0 || filter->last_pcr < 0) {
+        return timestamp;
+    }
+
+    /* if pcr is in the first third of its range of value 
+    and timestamp in the last third of its range then correct loopback value*/
+    if (filter->last_pcr < (300LL << 33)/3 && timestamp > (2LL << 33)/3) {
+        return timestamp + (filter->pcr_loopback_count - 1) * (1LL << 33);
+    }
+    /* if pcr is in the last third of its range of value 
+    and timestamp in the first third of its range then correct loopback value*/
+    else if (filter->last_pcr > (600LL << 33)/3 && timestamp < (1LL << 33)/3) {
+        return timestamp + (filter->pcr_loopback_count + 1) * (1LL << 33);
+    }
+    else {
+        return timestamp + (filter->pcr_loopback_count) * (1LL << 33);
+    }
+}
+
 static struct Program * get_program(MpegTSContext *ts, unsigned int programid)
 {
     int i;
@@ -1008,6 +1030,7 @@ static void new_data_packet(const uint8_t *buffer, int len, AVPacket *pkt)
 static int new_pes_packet(PESContext *pes, AVPacket *pkt)
 {
     uint8_t *sd;
+    MpegTSFilter* filter;
 
     av_packet_unref(pkt);
 
@@ -1028,8 +1051,18 @@ static int new_pes_packet(PESContext *pes, AVPacket *pkt)
         pkt->stream_index = pes->sub_st->index;
     else
         pkt->stream_index = pes->st->index;
-    pkt->pts = pes->pts;
-    pkt->dts = pes->dts;
+
+    //if PCR PID available then use PCR loopback count to preserve DTS and PTS continuity
+    if(pes->stream->correct_ts_overflow && pes->pcr_pid > 0){
+        filter = pes->ts->pids[pes->pcr_pid];
+        pkt->dts = preserve_continuity(filter, pes->dts);
+        pkt->pts = preserve_continuity(filter, pes->pts);
+    }
+    else{
+        pkt->dts = pes->dts;
+        pkt->pts = pes->pts;
+    }
+
     /* store position of first TS packet of this PES packet */
     pkt->pos   = pes->ts_packet_pos;
     pkt->flags = pes->flags;
@@ -2820,8 +2853,13 @@ static int handle_packet(MpegTSContext *ts, const uint8_t *packet, int64_t pos)
     if (has_adaptation) {
         int64_t pcr_h;
         int pcr_l;
-        if (parse_pcr(&pcr_h, &pcr_l, packet) == 0)
+        if (parse_pcr(&pcr_h, &pcr_l, packet) == 0) {
+            if ((tss->last_pcr - pcr_h * 300) > ((300LL<<33) - 27000000)){
+                ++tss->pcr_loopback_count;
+                av_log(ts->stream, AV_LOG_DEBUG, "PCR loopback detected\n");
+            }
             tss->last_pcr = pcr_h * 300 + pcr_l;
+        }
         /* skip adaptation field */
         p += p[0] + 1;
     }
@@ -2988,6 +3026,7 @@ static int handle_packets(MpegTSContext *ts, int64_t nb_packets)
                 }
                 ts->pids[i]->last_cc = -1;
                 ts->pids[i]->last_pcr = -1;
+                ts->pids[i]->pcr_loopback_count = 0;
             }
         }
     }
